Loading...
Searching...
No Matches
juce::MPEMessages Class Reference

## Detailed Description

This helper class contains the necessary helper functions to generate MIDI messages that are exclusive to MPE, such as defining the upper and lower MPE zones and setting per-note and master pitchbend ranges.

You can then send them to your MPE device using MidiOutput::sendBlockOfMessagesNow.

All other MPE messages like per-note pitchbend, pressure, and third dimension, are ordinary MIDI messages that should be created using the MidiMessage class instead. You just need to take care to send them to the appropriate per-note MIDI channel.

Note: If you are working with an MPEZoneLayout object inside your app, you should not use the message sequences provided here. Instead, you should change the zone layout programmatically with the member functions provided in the MPEZoneLayout class itself. You should also make sure that the Expressive MIDI zone layout of your C++ code and of the MPE device are kept in sync.

See also
  MidiMessage, MPEZoneLayout

The documentation for this class was generated from the following file:

- juce_audio_basics/mpe/juce_MPEMessages.h

## Static Public Member Functions

static MidiBuffer | setLowerZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the lower MPE zone.
static MidiBuffer | setUpperZone (int numMemberChannels=0, int perNotePitchbendRange=48, int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the upper MPE zone.
static MidiBuffer | setLowerZonePerNotePitchbendRange (int perNotePitchbendRange=48)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the lower MPE zone.
static MidiBuffer | setUpperZonePerNotePitchbendRange (int perNotePitchbendRange=48)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the upper MPE zone.
static MidiBuffer | setLowerZoneMasterPitchbendRange (int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the lower MPE zone.
static MidiBuffer | setUpperZoneMasterPitchbendRange (int masterPitchbendRange=2)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the upper MPE zone.
static MidiBuffer | clearLowerZone ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower zone.
static MidiBuffer | clearUpperZone ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the upper zone.
static MidiBuffer | clearAllZones ()
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower and upper zones.
static MidiBuffer | setZoneLayout (MPEZoneLayout layout)
| Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will reset the whole MPE zone layout of the device to the layout passed in.

## Static Public Attributes

static const int | zoneLayoutMessagesRpnNumber = 6
| The RPN number used for MPE zone layout messages.

## Member Functions

## setLowerZone()

MidiBuffer juce::MPEMessages::setLowerZone | ( | int | numMemberChannels = 0,
|  | int | perNotePitchbendRange = 48,
|  | int | masterPitchbendRange = 2 )

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the lower MPE zone.

## setUpperZone()

MidiBuffer juce::MPEMessages::setUpperZone | ( | int | numMemberChannels = 0,
|  | int | perNotePitchbendRange = 48,
|  | int | masterPitchbendRange = 2 )

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the upper MPE zone.

## setLowerZonePerNotePitchbendRange()

MidiBuffer juce::MPEMessages::setLowerZonePerNotePitchbendRange | ( | int | perNotePitchbendRange = 48 | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the lower MPE zone.

## setUpperZonePerNotePitchbendRange()

MidiBuffer juce::MPEMessages::setUpperZonePerNotePitchbendRange | ( | int | perNotePitchbendRange = 48 | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the per-note pitchbend range of the upper MPE zone.

## setLowerZoneMasterPitchbendRange()

MidiBuffer juce::MPEMessages::setLowerZoneMasterPitchbendRange | ( | int | masterPitchbendRange = 2 | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the lower MPE zone.

## setUpperZoneMasterPitchbendRange()

MidiBuffer juce::MPEMessages::setUpperZoneMasterPitchbendRange | ( | int | masterPitchbendRange = 2 | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will set the master pitchbend range of the upper MPE zone.

## clearLowerZone()

MidiBuffer juce::MPEMessages::clearLowerZone | ( |  | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower zone.

## clearUpperZone()

MidiBuffer juce::MPEMessages::clearUpperZone | ( |  | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the upper zone.

## clearAllZones()

MidiBuffer juce::MPEMessages::clearAllZones | ( |  | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will clear the lower and upper zones.

## setZoneLayout()

MidiBuffer juce::MPEMessages::setZoneLayout | ( | MPEZoneLayout | layout | ) |

static

Returns the sequence of MIDI messages that, if sent to an Expressive MIDI device, will reset the whole MPE zone layout of the device to the layout passed in.

This will first clear the current lower and upper zones, then then set the zones contained in the passed-in zone layout, and set their per-note and master pitchbend ranges to their current values.

## Member Data Documentation

## zoneLayoutMessagesRpnNumber

const int juce::MPEMessages::zoneLayoutMessagesRpnNumber = 6

static

The RPN number used for MPE zone layout messages.

Pitchbend range messages (both per-note and master) are instead sent on RPN 0 as in standard MIDI 1.0.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited